﻿#include "stdafx.h"
#include "MemoSendDlg.h"
#include "WorkGroupController.h"
#include "afxhtml.h"
#include <atlfile.h>
#include "RecvMemoDlg.h"
#include "CommonFunction.h"
#include "NeMessengerDlg.h"
#include "MemoDropTarget.h"
#include "MemoFileDropTarget.h"
#include "FileUploadController.h"
#include "SendMemoController.h"
#include "SendNoteMananger.h"
#include "ProfileWnd.h"




IMPLEMENT_DYNAMIC(CMemoSendDlg, CSkinDialog)

//move BTN_HEIGHT define from SendMemoButtons.h
#define BTN_HEIGHT				36
#define WM_ASYNC_DESTROYWINDOW  (WM_USER + 16)
CMemoSendDlg::CMemoSendDlg()
: CSkinDialog(CMemoSendDlg::IDD, NULL)
, m_lNoteNum(0)
, m_strWriteMode(_T("new"))
, m_bFileLimit(FALSE)
, m_nTotalSize(0)
, m_strTiTle(_T("")),m_bShowTitleEdit(FALSE)
, m_pDropTarget(new MemoDropTarget(this))
, m_pFileDropTarget(new MemoFileDropTarget())
, m_bInitializeSuccess(false)
, m_nUserMgrDiffHeight(0)
, m_bUserMgrResize(FALSE)
, m_pSendMemoController(new SendMemoController(this))
, m_pCreationDlg(NULL)
, m_bReplyContent(FALSE)
, m_bSetNoteInfo(FALSE)
, m_bSetFocus(FALSE)
, m_bDefaultExpand(false)
, m_bTopMost(FALSE)
, m_RsvDlg(this)
, m_pMSButtons(NULL)
{
	EnableCascade(true);
	m_attachFileInfoVector.clear();
	m_hBrushReserve = ::CreateSolidBrush(NSD_COMMON_BG_COLOR);
	m_hBrushParty = ::CreateSolidBrush(RGB(230,233,238));
    m_rcTitle.SetRectEmpty();
    m_rcTitleEdit.SetRectEmpty();
    
}

CMemoSendDlg::~CMemoSendDlg()
{
    SAFE_DELETE(m_pDropTarget);
    SAFE_DELETE(m_pFileDropTarget);
    SAFE_DELETE(m_pSendMemoController);

	DeleteObject(m_hBrushReserve);
	DeleteObject(m_hBrushParty);
}

BOOL CMemoSendDlg::Create(UINT nIDTemplate,CWnd* pParentWnd /* =NULL */)
{
	return CSkinDialog::Create(nIDTemplate,pParentWnd);
}


BOOL CMemoSendDlg::Create(CString strWriteModeParam,ULONGLONG lNoteNum,UINT nIDTemplate,CWnd* pParentWnd /* =NULL */, CWnd* pCreationDlg)
{
	m_strWriteMode = strWriteModeParam;
	m_lNoteNum = lNoteNum;
	m_pCreationDlg = pCreationDlg;
	return CSkinDialog::Create(nIDTemplate,pParentWnd);
}

BOOL CMemoSendDlg::Create(const std::vector<ReceiverInfo>& receiverVector, UINT nIDTemplate,CWnd* pParentWnd/*  =NULL */)
{
	m_receiverVector = receiverVector;
	return CSkinDialog::Create(nIDTemplate,pParentWnd);
}

BOOL CMemoSendDlg::Create(const std::vector<ReceiverInfo>& receiverVector, const std::vector<AttachFileInfo>& attachFileVector, UINT nIDTemplate,CWnd* pParentWnd/*  =NULL */)
{
	m_receiverVector = receiverVector;
	m_attachFileInfoVector = attachFileVector;
	return CSkinDialog::Create(nIDTemplate,pParentWnd);
}

vector<ReceiverInfo>* CMemoSendDlg::GetReceiverInfo()
{
	return &m_receiverVector;
}

void CMemoSendDlg::DoDataExchange(CDataExchange* pDX)
{
	CSkinDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_TITLE_EDIT, m_edMemoTitle);
	DDX_Control(pDX, IDC_EXPLORER1, m_SmartEditor);
	DDX_Text(pDX, IDC_TITLE_EDIT, m_strTiTle);
	DDX_Control(pDX, IDC_PARTY_CHECK, m_chkParty);
}

BEGIN_MESSAGE_MAP(CMemoSendDlg, CSkinDialog)
	ON_WM_PAINT()
	ON_WM_DESTROY()
	ON_WM_SIZE()	
	ON_WM_NCLBUTTONUP()
	ON_WM_LBUTTONUP()
	ON_WM_ERASEBKGND()	
	ON_WM_CREATE()
	ON_WM_NCHITTEST()
	ON_MESSAGE(UM_MEMO_SEND_PROGRESS, OnMemoFileSendProcess)
	ON_MESSAGE(UM_MEMO_SEND_CANCEL, OnMemoFileSendCancel)
	ON_MESSAGE(UM_MEMO_SEND_LIST_DELETE, OnMemoFileSendListDelete )
	ON_MESSAGE(UM_MEMO_SEND_SERVER_ERROR, OnMemoFileSendServerError)
	ON_MESSAGE(UM_MEMO_FILESEND_RESULT_WAIT, OnMemoFileSendResultWait )
	ON_MESSAGE(UM_MEMO_FILESEND_RESULT_COMPLETE, OnMemoFileSendResultComplete)
	

	ON_WM_CTLCOLOR()
	ON_WM_SETFOCUS()
	ON_WM_LBUTTONDOWN()
	ON_EN_UPDATE(IDC_TITLE_EDIT, &CMemoSendDlg::OnEnUpdateTitleEdit)
	ON_EN_KILLFOCUS(IDC_TITLE_EDIT, &CMemoSendDlg::OnEnKillfocusTitleEdit)
	ON_MESSAGE(UM_USERMGR_DELUSER,		OnUserMgrDelUser)
	ON_MESSAGE(UM_USERMGR_USERINFO,		OnUserMgrUserInfo)
	ON_MESSAGE(UM_USERMGR_RESIZE,		OnUserMgrResize)
	ON_MESSAGE(UM_USERMGR_ADDUSERBTN,	OnUserMgrAddUserBtn)
	ON_BN_CLICKED(IDC_PARTY_CHECK, &CMemoSendDlg::OnBnClickedPartyCheck)
	ON_MESSAGE(WM_MEMOSENDDLG_MESSAGE_POPUP_CLOSE, OnMessageBoxClose)
	ON_MESSAGE(WM_MEMOSENDDLG_MESSAGE_POPUP, OnMessageBox)
	ON_WM_TIMER()
	ON_MESSAGE(WM_CLICKCUSTOMBTN, OnBnClickedSendMemoMenuButton)
	ON_COMMAND(ID_SENDMEMO_TOP, &CMemoSendDlg::OnMenuTopMost)
	ON_COMMAND(ID_SENDMEMO_ADDUSER, &CMemoSendDlg::OnMenuAddUser)
	ON_COMMAND(ID_SENDMEMO_ADDFILE, &CMemoSendDlg::OnMenuAddFile)
	ON_COMMAND(ID_SENDMEMO_RSV, &CMemoSendDlg::OnMenuReservation)
END_MESSAGE_MAP()


BOOL CMemoSendDlg::OnInitDialog()
{
	CSkinDialog::OnInitDialog();

	SetSkin();

	RegisterWindowClassFileListAddressee();
	SetWindowTextAndSize();

	SetTitleEdit();
	ReSizeCtrl();
	SetDragAndDrop();

	SetLastPositionAndSize(this, _T("MemoSendDialog"));

	SetWindowTextColor(CColorConvert::HEX2Color(0xFFC8D1D8));
	SetWindowTextFontHeight(12);

	// AttachID를 미리 가져온다.
	g_pMessengerActor->GetWASActor()->RequestGetAttachID(&m_tridGetAttachID);

	m_bInitializeSuccess = true;

	//g_pos_memodlg.InitWindowInfo(this->m_hWnd);
	
	return FALSE;
}

void CMemoSendDlg::SetSendType(CString strWriteModeParam)
{
	m_strWriteMode = strWriteModeParam;
}

void CMemoSendDlg::__ResourceLoad(BOOL bInit)
{
	SetWindowText(LoadStringFromResource(IDS_STRING453));
	SetDialogShowWindowText(true);
	SetDialogWindowText(LoadStringFromResource(IDS_STRING453));

	if (m_chkParty.GetSafeHwnd())
	{	
		m_chkParty.SetFont(&g_ftDefault9PT);
		m_chkParty.SetWindowText(LoadStringFromResource(IDS_STRING571));
	}

	if (m_wndFileList.GetSafeHwnd())
	{
		m_wndFileList.__ResourceLoad();
	}

	if (bInit == TRUE)
	{
		SetLeftTopPNG(GetAppImgFile(_T("img_title_l.png")));
		SetCenterTopPNG(GetAppImgFile(_T("img_title_c.png")));
		SetRightTopPNG(GetAppImgFile(_T("img_title_r.png")));

		SetLeftBorderBitmap(GetAppImgFile(_T("new_02_left.bmp")));
		SetRightBorderBitmap(GetAppImgFile(_T("new_02_right.bmp")));

		SetLeftBottomPNG(GetAppImgFile(_T("img_bottom_l.png")));
		SetCenterBottomPNG(GetAppImgFile(_T("img_bottom_c.png")));
		SetRightBottomPNG(GetAppImgFile(_T("img_bottom_r.png")));
		SetUserBottomPNGBK(GetAppImgFile(_T("btn_popup_org_c_nor.png")));
		SetUserBottomPNG(GetAppImgFile(_T("btn_popup_org_bar.png")));

		SetExitBitmaps(GetAppImgFile(_T("btn_common_cancel_nor.bmp")),
			GetAppImgFile(_T("btn_common_cancel_foc.bmp")), GetAppImgFile(_T("btn_common_cancel_pre.bmp")));
		SetCloseEvent(TRUE);

		//SetCustomBitmaps(GetAppImgFile(_T("new_main_menu.bmp")), GetAppImgFile(_T("new_main_menu_over.bmp")), GetAppImgFile(_T("new_main_menu_click.bmp")));
		//ShowCustomBtn(true);

		m_edMemoTitle.SetFont(&g_ftDefault9PT);
		m_chkParty.SetFont(&g_ftDefault9PT);

		m_edMemoTitle.GetWindowRect(&m_rcTitleEdit);
	}
	else
	{
		SendMessage(WM_SIZE, NULL, NULL);
	}

}


BOOL CMemoSendDlg::SetUserBottomPNGBK(CString strPath)
{
	HBITMAP hBitmap = LoadPngToBmp(strPath);
	if(hBitmap == NULL)
	{
		return FALSE;
	}

	Global.SetUserBottomBitmapBK(hBitmap);
	m_sizeUserBottomBK		= Global.GetBitmapSize(IDX_BMP_FRAME_USER_BOTTOM_BK);
	m_hBmpUserBottomBK		= Global.GetBitmap(IDX_BMP_FRAME_USER_BOTTOM_BK);

	return TRUE;
}

BOOL CMemoSendDlg::SetUserBottomPNG(CString strPath)
{
	HBITMAP hBitmap = LoadPngToBmp(strPath);
	if(hBitmap == NULL)
	{
		return FALSE;
	}

	Global.SetUserBottomBitmap(hBitmap);
	m_sizeUserBottom		= Global.GetBitmapSize(IDX_BMP_FRAME_USER_BOTTOM);
	m_hBmpUserBottom		= Global.GetBitmap(IDX_BMP_FRAME_USER_BOTTOM);

	return TRUE;
}

/*!
*  @fn void SearchUserName()
*  @brief     받는 사람의 이름을 찾는다. 
*  @return    
*  @param     CString strUserID
*  @author	  jeongseok.han(@nhn.com) 
*  @date      2012/023/10
*  @warning   즐겨찾기 리스트와 조직도 사원 검색 결과에서 이름을 찾는다. 향후 사원 정보 관리모듈로 부터 찾도록 수정해야 한다.
*/
CString CMemoSendDlg::SearchUserName(CString strUserID)
{
	CString strUserName;

	// 즐겨찾기 리스트
	const IGTBuddyUser* pUser = g_pMessengerActor->GetBuddyInfo(strUserID);
	if( pUser != NULL )
		strUserName = pUser->GetName();

	// 조직도 사원 리스트
	if( strUserName.IsEmpty())
		strUserName =  ((CNeMessengerDlg*)theApp.m_pMainWnd)->GetWorkGroupController()->GetMemberName(strUserID);

	return strUserName;
}

void CMemoSendDlg::OnPaint()
{
	CPaintDC dc(this);
}

void CMemoSendDlg::OnDestroy()
{
	//g_pos_memodlg.UpdateDlgNum();

	if (m_wndUserMgr.GetSafeHwnd())
		m_wndUserMgr.DestroyWindow();

	if (m_wndFileList.GetSafeHwnd())
		m_wndFileList.DestroyWindow();

	if(m_pMSButtons)
	{
		::DestroyWindow(m_pMSButtons->GetHWND());
		SAFE_DELETE(m_pMSButtons);
	}

	CSkinDialog::OnDestroy();
}

LRESULT CMemoSendDlg::OnNcHitTest(CPoint point)
{
	int ret = CDialog::OnNcHitTest(point);
	if((HTTOP == ret || HTBOTTOM == ret || HTLEFT == ret || HTRIGHT == ret || HTBOTTOMLEFT == ret || HTBOTTOMRIGHT == ret || HTTOPLEFT == ret || HTTOPRIGHT == ret) 
		&& m_bMaxWnd)
		return HTCLIENT;
	return ret;
}

BOOL CMemoSendDlg::PreTranslateMessage(MSG* pMsg)
{

	CWnd* pWndCurrentFocus = GetFocus();
	if (m_hWnd != pMsg->hwnd && !IsChild(FromHandle(pMsg->hwnd))) //It means the msg has No matter with memo window, return false.
	{
		
		return FALSE;
	}
	
	
	if(pMsg->message == WM_KEYDOWN && ::GetAsyncKeyState(VK_CONTROL) < 0 && m_SmartEditor.GetSafeHwnd() == pWndCurrentFocus->GetSafeHwnd())
	{       
		if(_T('z') == (TCHAR)pMsg->wParam || _T('Z') == (TCHAR)pMsg->wParam)
			return TRUE;
	}

	if( IsCloseMsg(pMsg) )
	{
		CloseDialog();		
		return TRUE;
	}
	
	if(pMsg->message == WM_RESERVE_SELECT_CHANGED)
	{
		OnRsvSelectedChange();
		return TRUE;
	}

	if(pMsg->message == WM_EXPAND_CHANGED)
	{
		OnExpandChanged((bool)pMsg->wParam, (int)pMsg->lParam);
		return TRUE;
	}
	if(pMsg->message == WM_ASYNC_DESTROYWINDOW)
	{
		DestroyWindow();
		return TRUE;
	}

	if( pMsg->message == WM_KEYDOWN )
	{
		if( pMsg->wParam == VK_F5 )
		{
			return TRUE;
		}
		else if( pMsg->wParam == VK_RETURN )
		{
			TranslateMessage( pMsg );
			GetFocus()->SendMessage( pMsg->message, pMsg->wParam, pMsg->lParam );
			return TRUE;
		}
		else
		{
			CWnd* pWndFocus = GetFocus();
			CMemoSendAttachList* pWndFileList = m_wndFileList.GetFileListCtrl();
			if (pWndFocus && pWndFileList && (pWndFocus->GetSafeHwnd() == pWndFileList->GetSafeHwnd()))
			{
				pWndFileList->SendMessage(pMsg->message, pMsg->wParam, pMsg->lParam);
				return TRUE;
			}
		}
	}

	else if (GetKeyState(VK_MENU) < 0 && m_pMSButtons->GetButtonReadOnly(COKCancelButtons::OK))
	{
		if (pMsg->message != WM_SYSKEYDOWN && pMsg->message != WM_SYSKEYUP) // 避免和 WM_SYSKEYDOWN 时WPARAM=0X73（F4）冲突
		{
			if (_T('s') == (TCHAR)pMsg->wParam || _T('S') == (TCHAR)pMsg->wParam)
			{
				OnBnClickedSendButton();
				return TRUE;
			}		
		}
		
	}

	return __super::PreTranslateMessage(pMsg);
}

void CMemoSendDlg::OnSize(UINT nType, int cx, int cy)
{
	__super::OnSize(nType, cx, cy);

	ReSizeCtrl();
	::RedrawWindow(GetSafeHwnd(), NULL, NULL, RDW_ERASE | RDW_INVALIDATE | RDW_FRAME | RDW_ALLCHILDREN);
}

void CMemoSendDlg::ReSizeCtrl(void)
{
	//리사이징 할 핸들을 체크
	if (m_edMemoTitle.GetSafeHwnd() == NULL || m_SmartEditor.GetSafeHwnd()==NULL || m_pMSButtons == NULL)
	{
		return;
	}

    CRect rcClient(0, 0, 0, 0);
	GetClientRect(&rcClient);

	int nSX = 0, nSY = 0, nCX = 0, nCY = 0, nEX = 0, nEY = 0;

	//-----------------------------------------------------------------------------
	// by cscho(xxxx)
	// New UI
	CRect rtUserMgr(0, 0, 0, 0);
	if (m_wndUserMgr.GetSafeHwnd())
	{
		CRect rtTemp(0, 0, 0, 0);
		m_wndUserMgr.GetWindowRect(&rtTemp);

		if (rtTemp.IsRectEmpty())
		{
			nSX = DEF_USERMGR_REL_LEFT_POS_X;
			nSY = DEF_USERMGR_REL_TOP_POS_Y;
			nCX = rcClient.Width() - DEF_USERMGR_REL_LEFT_POS_X - DEF_USERMGR_REL_RIGHT_POS_X;
			nCY = DEF_USERMGR_HEIGHT;
			rtUserMgr.SetRect(nSX, nSY, nSX + nCX, nSY + nCY);
		}
		else
		{
			ScreenToClient(&rtTemp);
			rtUserMgr = rtTemp;
			rtUserMgr.right = rtUserMgr.left + (rcClient.Width() - DEF_USERMGR_REL_LEFT_POS_X - DEF_USERMGR_REL_RIGHT_POS_X);
		}

		if (m_bUserMgrResize)
		{
			rtUserMgr.InflateRect(0, 0, 0, m_nUserMgrDiffHeight);
		}
		m_wndUserMgr.MoveWindow(&rtUserMgr);
	}

	CRect rtMemoTitle(0, 0, 0, 0);
	if (m_edMemoTitle.GetSafeHwnd())
	{
		nSX = NSD_DEF_TITLE_EDIT_POS_X;
		nSY = NSD_DEF_TITLE_EDIT_POS_Y;
		nSY = (rtUserMgr.bottom + 5) + 3;
		nCX = rcClient.Width() - NSD_DEF_TITLE_EDIT_POS_X - 100;
		nCY = COMMON_EDIT_HEIGHT - 6;
		rtMemoTitle.SetRect(nSX, nSY, nSX + nCX, nSY + nCY);
		m_edMemoTitle.MoveWindow(&rtMemoTitle);
	}

	m_rcTitleEdit.top=rtMemoTitle.top;
	m_rcTitleEdit.left=rtMemoTitle.left;
	m_rcTitleEdit.bottom=nSY+COMMON_EDIT_HEIGHT;
	m_rcTitleEdit.right=rcClient.Width()-86;



	CRect rcChkParty(0, 0, 0, 0);
	if (m_chkParty.GetSafeHwnd())
	{
		nSX = rcClient.right - 96;
		nSY = NSD_DEF_PARTY_CHECK_POS_Y;
		nSY = (rtUserMgr.bottom + 7);
		nCX = NSD_DEF_PARTY_CHECK_WIDTH +10;
		nCY = NSD_DEF_PARTY_CHECK_HEIGHT;
		rcChkParty.SetRect(nSX, nSY, nSX + nCX, nSY + nCY);
		m_chkParty.MoveWindow(&rcChkParty);

	}

	if(m_pMSButtons && m_pMSButtons->GetHWND())
	{
		CRect rcButtons(rcClient.left, rcClient.bottom+7 - BTN_HEIGHT, rcClient.right, rcClient.bottom + 7);
		m_pMSButtons->SetClientRect(rcButtons);
	}

	/*CRect rtChkReserve(0, 0, 0, 0);
	if (m_chkReserve.GetSafeHwnd())
	{
		nSX =  10;
		nSY = rcClient.bottom-39;
		nCX = NSD_DEF_RSV_CHECK_WIDTH + 10;
		nCY = NSD_DEF_RSV_CHECK_HEIGHT;
		rtChkReserve.SetRect(nSX, nSY, nSX + nCX, nSY + nCY);
		m_chkReserve.MoveWindow(&rtChkReserve);
	}*/

	CPoint ptLeftTop(0, 0);
	if (m_wndFileList.GetSafeHwnd())
	{
		/*int nSX = rcClient.left;
		int nCX = rcClient.Width();
		int nCY = 160;
		int nSY = rcClient.bottom - BTN_HEIGHT + 7 - nCY;*/		
		CPoint ptRightButtom(0, 0);
		ptRightButtom.x = rcClient.right;
		ptRightButtom.y = rcClient.bottom - BTN_HEIGHT + 7;
		//rtAttachList.SetRect(nSX, nSY, nSX + nCX, nSY + nCY);
		ptLeftTop = m_wndFileList.ReSizeWindow(&ptRightButtom);
	}

	CRect rtSmartEditor(0, 0, 0, 0);
	if (m_SmartEditor.GetSafeHwnd())
	{
		nSX = 0;
		nSY = (m_rcTitleEdit.bottom + 10);
		nCX = rcClient.Width();
		nEY = ptLeftTop.y;
		rtSmartEditor.SetRect(nSX, nSY, nSX + nCX, nEY);
		m_SmartEditor.MoveWindow(&rtSmartEditor);
	}

	m_wndUserMgr.UpdateWndInfo(NULL);

	m_bUserMgrResize = FALSE;
	m_nUserMgrDiffHeight = 0;

}

void CMemoSendDlg::OnNcLButtonUp(UINT nHitTest, CPoint point)
{
	__super::OnNcLButtonUp(nHitTest, point);
}

void CMemoSendDlg::OnLButtonUp(UINT nFlags, CPoint point)
{
	__super::OnLButtonUp(nFlags, point);
}

BOOL CMemoSendDlg::OnEraseBkgnd(CDC* pDC)
{
	//EraseBkgnd에서 배경을 그려야 잔상효과가 없다. Yangjae.park
	CRect rcClient(0, 0, 0, 0);
	GetClientRect(&rcClient);

	CRect rcRecvUserBG(0, 0, 0, 0);
	rcRecvUserBG.SetRect(0,0,rcClient.Width(),93);

	NMMemDC dcMem;
	dcMem.CreateCompatibleDC(pDC,rcClient.Width(), rcClient.Height());
	dcMem.FillSolidRect(rcClient,RGB(255,255,255));
	dcMem.FillSolidRect(rcRecvUserBG,RGB(230,233,238));

	dcMem.SetBkMode(TRANSPARENT);
	COLORREF oldColor = dcMem.SetTextColor(COMMON_TEXT_COLOR);
	UINT nTextStyle = DT_LEFT|DT_SINGLELINE|DT_TOP;

	CRect rt(0, 0, 0, 0);
	rt.SetRect(NSD_DEF_RECV_USER_POS_X,NSD_DEF_RECV_USER_POS_Y,NSD_DEF_RECV_USER_POS_X+NSD_DEF_RECV_USER_WIDTH,NSD_DEF_RECV_USER_POS_Y+NSD_DEF_RECV_USER_HEIGHT);
	CFont *pOldFont = dcMem.SelectObject(&g_ftDefault9PT);
	dcMem.DrawText(LoadStringFromResource(IDS_STRING458),rt,nTextStyle);
	m_edMemoTitle.GetWindowRect(&rt);
	ScreenToClient(&rt);
	rt.SetRect(NSD_DEF_TITLE_POS_X,rt.top,NSD_DEF_TITLE_POS_X+NSD_DEF_TITLE_WIDTH,rt.top+NSD_DEF_TITLE_HEIGHT);
	dcMem.DrawText(LoadStringFromResource(IDS_STRING459),rt,nTextStyle);

	if (m_edMemoTitle.GetSafeHwnd() && m_edMemoTitle.IsWindowVisible())
	{
		CRect rcEdit(0, 0, 0, 0);
		m_edMemoTitle.GetWindowRect(rcEdit);
		ScreenToClient(rcEdit);

		rcEdit.InflateRect(1,6);
		rcEdit.OffsetRect(0, 0);
		CPen penEditBox;
		penEditBox.CreatePen(PS_SOLID,1,COMMON_EDIT_BORDER_COLOR);

		CPen *pOldPen= dcMem.SelectObject(&penEditBox);
		dcMem.Rectangle(rcEdit);
		dcMem.SelectObject(pOldPen);
	}

	::BitBlt(pDC->m_hDC, rcClient.left, rcClient.top, rcClient.Width(), rcClient.Height(), dcMem.m_hDC, 0, 0, SRCCOPY);

	dcMem.SelectObject(&pOldFont);
	dcMem.SelectObject(&oldColor);
	dcMem.DeleteDC();

	return TRUE;
}

BOOL CMemoSendDlg::AddRecvUser(CString strID,CString strName,int nAddUserCount)
{
	if(strName==L"")
	{
		strName=SearchUserName(strID);
	}
	if(AddNoteReceiver(strID, strName))
	{
		m_wndUserMgr.AddUserMgrItem(strID, strName);
		return TRUE;
	}
	return FALSE;

}

void CMemoSendDlg::OnBnClickedSendButton()
{
	NTALK_LOG->Debug(L"[NOTE] ClickedSendButton");

	m_bFileLimit=FALSE;
	UpdateData(TRUE);
	CString strTitle = _T("");
	CString strContent = _T("");
	m_edMemoTitle.GetWindowText(strTitle);

	strContent = GetSmartEditorDocument();
	std::string strToList = UnicodeToURIEncode(GetReceiverIDs()) ;
	if(strToList =="")
	{
		
		NMessageBox(this, LoadStringFromResource(IDS_STRING534));
		return;
	}
	if(strTitle =="" && strContent=="" && m_wndFileList.GetFileItemCount() == 0 )
	{
		NMessageBox(this, LoadStringFromResource(IDS_STRING543));
		return;
	}

	DisableSend();

	SetTicket(g_pMessengerActor->GetMessengerTicket());
	SetSubject(strTitle);
	SetContent(strContent);
	SetAttachID(m_pSendMemoController->GetFileAttachID().c_str());

	if( SendMemo(m_tridSendNote) != TRUE )
	{
		NMessageBox(this, LoadStringFromResource(IDS_STRING460));
		EnableSend();
	}
}

void CMemoSendDlg::OnBnClickedCancelButton()
{
	CloseDialog();
}

UINT_PTR CALLBACK CdlgHook(  HWND hdlg,UINT uiMsg,WPARAM /*wParam*/, LPARAM lParam)
{
	if(uiMsg == WM_INITDIALOG)
	{
		CHOOSECOLOR *pcc = (CHOOSECOLOR*)lParam;
		CRect *rc = (CRect*)pcc->lCustData;
		if(rc)
			SetWindowPos(hdlg,HWND_TOP,rc->right,rc->bottom,
			0,0,SWP_NOZORDER|SWP_NOSIZE);
		CString str;
		str.LoadString(IDS_STRING168);
		SetWindowText(hdlg,str);
		delete rc;
	}
	return 0;
}

void CMemoSendDlg::OnRsvSelectedChange()
{
	if(m_wndFileList.GetReserveCheck())
	{
        GET_MESSENGER_DLG()->RegisterMfcModalDlg(&m_RsvDlg);
        int nRet = m_RsvDlg.DoModal();
        GET_MESSENGER_DLG()->UnRegisterMfcModalDlg(&m_RsvDlg);

		if(nRet==IDOK)
		{
			SetReservationCheck(TRUE);
			SetTimeZone(m_RsvDlg.m_strTimeZone);
			SetReservationTime(m_RsvDlg.m_strRsvTime);
		}
		else
		{
			SetReservationCheck(FALSE);
			m_wndFileList.SetReserveCheck(false);

		}
	}
	else
	{
		SetReservationCheck(FALSE);
	}
}

int CMemoSendDlg::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	lpCreateStruct->cx = NSD_DEF_MIN_SIZE_WIDTH;
	lpCreateStruct->cy = NSD_DEF_MIN_SIZE_HEIGHT;
	if (CSkinDialog::OnCreate(lpCreateStruct) == -1)
		return -1;


	m_pMSButtons = new COKCancelButtons(this, this);
	m_pMSButtons->LoadSkin();

	CString strButtonOK = LoadStringFromResource(IDS_STRING577);
	strButtonOK.Append(_T("(S)"));
	m_pMSButtons->SetButtonText(strButtonOK, LoadStringFromResource(IDS_STRING569));
	return 0;
}

void CMemoSendDlg::SetSkin()
{
	TCHAR szStylesPath[_MAX_PATH];

	VERIFY(::GetModuleFileName(AfxGetApp()->m_hInstance, szStylesPath, _MAX_PATH));		

	CString strStylesPath = szStylesPath;
	int nIndex  = strStylesPath.ReverseFind(_T('\\'));
	if (nIndex > 0) {
		strStylesPath = strStylesPath.Left(nIndex);
	}
	else {
		strStylesPath.Empty();
	}
	strStylesPath += _T("\\Style\\");

	CXTPSkinManager* pSkinManager = XTPSkinManager();

	pSkinManager->ApplyWindow(m_chkParty.GetSafeHwnd());

	CXTPSkinManagerSchema* pSchema = pSkinManager->CreateSchema(GetAppImgDir()+_T("\\style\\Ntalk.cjstyles"), _T("WorkGroupDlg.ini"));
	CMDTARGET_RELEASE(pSchema);
}

LRESULT CMemoSendDlg::OnMemoFileSendCancel(WPARAM wParam, LPARAM lParam)
{
	TRACE("%s%d\n", __FUNCTION__, __LINE__);
	int nIndex=(int)wParam;
	if (m_wndFileList.GetSafeHwnd())
		m_wndFileList.UpdateFileDelete(nIndex);



	return 0;

}
LRESULT CMemoSendDlg::OnMemoFileSendListDelete( WPARAM wParam, LPARAM lParam )
{
	TRACE("%s%d\n", __FUNCTION__, __LINE__);

	int nIndex=(int)wParam;

	NTALK_LOG->Debug(L"[NOTE] DeleteSendList= %d.", nIndex);

	if (m_wndFileList.GetSafeHwnd())
		m_wndFileList.UpdateFileListDelete(nIndex);

	return 0;
}

LRESULT	CMemoSendDlg::OnMemoFileSendProcess(WPARAM wParam, LPARAM lParam)
{
	CString strMsg = _T("");

	int index = (int)wParam;
	DWORD dwSendLength = (DWORD)lParam;

	if (m_wndFileList.GetSafeHwnd())
		m_wndFileList.UpdateFileAttachProgress(index, dwSendLength);

	return 0;
}

LRESULT CMemoSendDlg::OnMemoFileSendServerError( WPARAM wParam, LPARAM lParam )
{
	const FILE_UPLOAD_RESULT_DATA* fileUploadData=(FILE_UPLOAD_RESULT_DATA*)wParam;
	
	NTALK_LOG->Error(L"[NOTE] FileSendServerError = %s", fileUploadData->strErrMsg.c_str());

	NMessageBox(this, fileUploadData->strErrMsg.c_str());
	EnableSend();
	return 0;
}

LRESULT CMemoSendDlg::OnMemoFileSendResultWait( WPARAM wParam, LPARAM lParam )
{
	TRACE("%s%d\n", __FUNCTION__, __LINE__);
	int nIndex=(int)wParam;
	if (m_wndFileList.GetSafeHwnd())
		m_wndFileList.FileSendResultWait(nIndex);



	return 0;
}

LRESULT CMemoSendDlg::OnMemoFileSendResultComplete( WPARAM wParam, LPARAM lParam )
{
	TRACE("%s%d\n", __FUNCTION__, __LINE__);
	int nIndex=(int)wParam;
	if (m_wndFileList.GetSafeHwnd())
		m_wndFileList.FileSendResultComplete(nIndex);

	return 0;
}

void CMemoSendDlg::SetMemoTitle(CString strTitle)
{
	m_edMemoTitle.SetWindowText(strTitle);
}

void CMemoSendDlg::SetMemoDocument(CString strDocument)
{

}

HBRUSH CMemoSendDlg::OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor)
{
	if (nCtlColor == CTLCOLOR_BTN)
	{
		if (pWnd->GetDlgCtrlID() == IDC_RESERVE_CHECK)
			return m_hBrushReserve;
		else if (pWnd->GetDlgCtrlID() == IDC_PARTY_CHECK)
			return m_hBrushParty;
	}

	return __super::OnCtlColor(pDC, pWnd, nCtlColor);
}

void CMemoSendDlg::OnSetFocus(CWnd* pOldWnd)
{
	CDialog::OnSetFocus(pOldWnd);

	IUnknown* pUnk = m_SmartEditor.GetControlUnknown();
	if (pUnk)
	{
		IOleWindow* pOleWindow = NULL;
		HRESULT hr = pUnk->QueryInterface(IID_IOleWindow, 
			(void**)&pOleWindow);
		if (SUCCEEDED(hr))
		{
			HWND hWnd;
			hr = pOleWindow->GetWindow(&hWnd);
			if (SUCCEEDED(hr)) ::SetFocus(hWnd);
			if (pOleWindow) pOleWindow->Release();
		}
	}

}

void CMemoSendDlg::CloseDialog()
{
//	GT_FLOG(L"senddlg close");
	m_wndFileList.ExpandAttachList(FALSE);
	m_wndFileList.CloseModalDialog();

	if( m_RsvDlg.GetSafeHwnd() != NULL)
	{
		m_RsvDlg.SendMessage(WM_CLOSE, 0 ,0);
	}
	ShowWindow(SW_HIDE);
	if( m_SmartEditor.m_hWnd != NULL )
	{
		m_SmartEditor.BlankDocument();
		m_SmartEditor.DestroyWindow();
	}

	::SetProcessWorkingSetSize( ::GetCurrentProcess( ), -1, -1 );

	CNeMessengerApp* pApp = (CNeMessengerApp*)AfxGetApp();
	pApp->m_pSendNoteManager->Remove(this);

	PostMessage(WM_ASYNC_DESTROYWINDOW, 0, 0);
}

void CMemoSendDlg::ExecScript(const CString &strFunction)
{
//	GT_FLOG(L"exe script");
	if (strFunction.GetLength() == 0)
		return;

	COleVariant varRet;
	HRESULT hr;
	IHTMLDocument2* pHTMLDocument2 = NULL;
	IHTMLWindow2* pHTMLWindow2 = NULL;
	LPDISPATCH lpDispatch = NULL;

	// 2013.01.31.
	// CComPtr을 사용해서 IDispatch를 받아올 경우 자동으로 Release가 되지 않아 Leak이 발생한다
	// 그래서 IDispatch를 직접 받아서 명시적으로 Release를 해주도록 변경함
	// CComPtr을 사용해도 메모리/핸들 leak이 발생하지 않는다면 사용해도 무방함
	lpDispatch = m_SmartEditor.get_Document();

	if (lpDispatch)
	{
		hr = lpDispatch->QueryInterface(IID_IHTMLDocument2, (void**)&pHTMLDocument2);

		if (SUCCEEDED(hr))
		{
			hr = pHTMLDocument2->get_parentWindow(&pHTMLWindow2);
			
			if (SUCCEEDED(hr))
			{
				pHTMLWindow2->execScript(CComBSTR((LPCTSTR)strFunction), CComBSTR(_T("JScript")), &varRet);
				pHTMLWindow2->Release();
			}

			pHTMLDocument2->Release();
		}

		lpDispatch->Release();
	}
}

CString CMemoSendDlg::ExecScript2(CString strFunction)
{
//	GT_FLOG(L"exe script2");
	if (strFunction.GetLength() == 0)
		return _T("");

	CString strResult = _T("");
	HRESULT hr;
	CComVariant vtResult(0);
	CComPtr<IHTMLDocument2> spDocument = NULL;
	LPDISPATCH lpDispatch = NULL;
	LPDISPATCH lpDispScript = NULL;

	lpDispatch = m_SmartEditor.get_Document();

	if (lpDispatch)
	{
		hr = lpDispatch->QueryInterface(IID_IHTMLDocument2, (void**)&spDocument);

		if (SUCCEEDED(hr))
		{
			hr = spDocument->get_Script(&lpDispScript);

			if (SUCCEEDED(hr) && lpDispScript != NULL)
			{
				_bstr_t   bstrFunction(strFunction);
				DISPID dispid;

				hr = lpDispScript->GetIDsOfNames(IID_NULL, &bstrFunction.GetBSTR(), 1,
					LOCALE_SYSTEM_DEFAULT, &dispid);
				DISPPARAMS dispparams;
				memset(&dispparams, 0, sizeof(dispparams));
				dispparams.cArgs = 0;
				dispparams.cNamedArgs = 0;

				if(SUCCEEDED(hr))
				{
					hr = lpDispScript->Invoke(dispid, IID_NULL, LOCALE_USER_DEFAULT, 
						DISPATCH_METHOD, &dispparams, &vtResult, NULL, NULL);
					strResult = (LPCTSTR)_bstr_t(vtResult);
				}

				lpDispScript->Release();
			}
		}

		lpDispatch->Release();
	}

	return strResult;
}

const CString CMemoSendDlg::GetSmartEditorDocument()
{
	return ExecScript2(_T("getSmartEditor"));
}

void CMemoSendDlg::OnLButtonDown(UINT nFlags, CPoint point)
{
	if (point.x >m_rcTitleEdit.left && point.x <m_rcTitleEdit.right &&
		point.y>m_rcTitleEdit.top && point.y<m_rcTitleEdit.bottom)
	{
		m_bShowTitleEdit=TRUE;
		m_edMemoTitle.ShowWindow(SW_SHOW);
		m_edMemoTitle.SetFocus();
	}

	CRect rt(0, 0, 0, 0);
	rt.top = m_rcTitleEdit.top - 2;
	rt.left = m_rcTitleEdit.left - 2;
	rt.right = m_rcTitleEdit.right + 2;
	rt.bottom = m_rcTitleEdit.bottom + 2;

	InvalidateRect(rt);

	__super::OnLButtonDown(nFlags, point);
}

void CMemoSendDlg::OnEnUpdateTitleEdit()
{
	UpdateData(TRUE);

	if( m_strTiTle.IsEmpty() )
		m_bShowTitleEdit = FALSE;
	else
		m_bShowTitleEdit = TRUE;
}

void CMemoSendDlg::OnEnKillfocusTitleEdit()
{
	CRect rt(0, 0, 0, 0);
	rt.top = m_rcTitleEdit.top-2;
	rt.left = m_rcTitleEdit.left-2;
	rt.right = m_rcTitleEdit.right+2;
	rt.bottom=m_rcTitleEdit.bottom+2;
	InvalidateRect(rt);
}

bool CMemoSendDlg::IsInitializeSuccess(void)
{
	return m_bInitializeSuccess;
}

void CMemoSendDlg::SetDragAndDrop()
{
	if (NULL != m_pDropTarget) m_pDropTarget->Register(&m_wndUserMgr);	
	if (NULL != m_pFileDropTarget) m_pFileDropTarget->Register(m_wndFileList.GetFileListCtrl());
}

void CMemoSendDlg::SetReadOnly( BOOL bStatus )
{
	m_edMemoTitle.SetReadOnly(bStatus);

	BOOL bValue = !bStatus;

	m_pMSButtons->SetButtonReadOnly(bValue, COKCancelButtons::All );
	m_SmartEditor.EnableWindow(bValue);

	Invalidate();

}

LRESULT CMemoSendDlg::OnUserMgrDelUser(WPARAM wParam, LPARAM lParam)
{
	CInfoUserMgrWnd::_usermgr_item_info* pUMInfo = (CInfoUserMgrWnd::_usermgr_item_info*)lParam;
	if (!pUMInfo)
		return 0L;

	RemoveNoteReceiver(pUMInfo->strID);

	return 1L;
}

LRESULT CMemoSendDlg::OnUserMgrAddUserBtn(WPARAM wParam, LPARAM lParam)
{
	GET_MESSENGER_DLG()->GetWorkGroupController()->OpenAddUserDlg(this, ADD_USER_FROM_NOTE);
	return 1L;
}

void CMemoSendDlg::AddUser(std::vector<NE_MEMBER_DATA>& vAddUsers)
{
	CString strMsg;
	LRESULT res = IsEnableReceiverUserCount( GetCurrentReceiverCount() + (int)(vAddUsers.size()) );

	if (res != 0L)
	{
		if(res == 1L)		strMsg.LoadString(IDS_STRING296);
		else if(res == 2L)	strMsg.LoadString(IDS_STRING300);
		else if(res == 3L)	strMsg.LoadString(IDS_STRING298);

		NMessageBox(this, strMsg);
	}
	std::vector<NE_MEMBER_DATA>::const_iterator iter = vAddUsers.begin();
	for(; iter != vAddUsers.end(); ++iter)
	{
		NE_MEMBER_DATA data = *iter;
		AddRecvUser(data.strUserId.c_str(),data.strName.c_str());
	}
}

LRESULT CMemoSendDlg::OnUserMgrUserInfo(WPARAM wParam, LPARAM lParam)
{
	CInfoUserMgrWnd::_usermgr_item_info* pUMInfo = (CInfoUserMgrWnd::_usermgr_item_info*)lParam;
	if (!pUMInfo)
		return 0L;

	// ID가 'or_' 또는 'wg_' 로 시작하는 것은 DL 이라 사용자 정보창을 띄우지 않는다.
	if (pUMInfo->strID.Left(3) == _T("or_") || pUMInfo->strID.Left(3) == _T("wg_"))
		return 0L;

	RECT rcMem = {0};
	m_wndUserMgr.GetWindowRect(&rcMem);
//	pUMInfo->GetWindowRect(&rcMem);
	RECT rcAround = {rcMem.left + pUMInfo->rtItem.left, rcMem.top + pUMInfo->rtItem.top, rcMem.left + pUMInfo->rtItem.right, rcMem.top + pUMInfo->rtItem.bottom};

	GET_MESSENGER_DLG()->GetProfileDlgController()->CreateProfileDlg(pUMInfo->strID,rcAround, GetSafeHwnd());

	return 1L;
}

LRESULT CMemoSendDlg::OnUserMgrResize(WPARAM wParam, LPARAM lParam)
{
	m_nUserMgrDiffHeight = (int)lParam;

	m_bUserMgrResize = TRUE;

	CRect rtClient(0, 0, 0, 0);
	GetClientRect(&rtClient);

	SendMessage(WM_SIZE, (WPARAM)SIZE_RESTORED, MAKELPARAM(rtClient.Width(), rtClient.Height() + m_nUserMgrDiffHeight));

	return 1L;
}

void CMemoSendDlg::PostNcDestroy()
{
	CSkinDialog::PostNcDestroy();

	delete this;
}

void CMemoSendDlg::EnableSend()
{
	if(m_pMSButtons != NULL && m_pMSButtons->GetHWND() != NULL)
	{

		m_pMSButtons->SetButtonReadOnly(true, COKCancelButtons::OK);
	}
}

void CMemoSendDlg::DisableSend()
{
	if(m_pMSButtons != NULL && m_pMSButtons->GetHWND() != NULL)
	{

		m_pMSButtons->SetButtonReadOnly(false, COKCancelButtons::OK);
	}
}

bool CMemoSendDlg::IsCloseMsg( MSG* pMsg )
{
	bool result = false;
	
    if (pMsg->message == WM_CLOSE )
    {
		result = true;
    }
	if ((pMsg->message == WM_KEYDOWN && pMsg->wParam == VK_ESCAPE) || (pMsg->message == WM_SYSKEYDOWN && pMsg->wParam == VK_F4) )
	{
		/*if (g_pProfileWnd != NULL && IsWindow(g_pProfileWnd->GetHWND()) && GetSafeHwnd() == g_pProfileWnd->GetParentHwnd())
		{			

			g_pProfileWnd->CloseProfileWnd();
		}
		else*/
		{	
			
			result = true;
			
		}
	}
	if(pMsg->message == WM_SYSCOMMAND && pMsg->wParam == SC_CLOSE) {

		result = true;
	}

	return result;
}

bool CMemoSendDlg::IsNeedToOmmit( ReceiverInfo &receiverInfo )
{
	GT_MY_USER_DATA myUserData;
	g_pMessengerActor->GetMyUserInfo(myUserData);

	return (0 == m_strWriteMode.CompareNoCase(_T("replyAll")) && 0 == receiverInfo.strID.compare(myUserData.strUserID));
}

void CMemoSendDlg::CloseRecvNoteDlg()
{
	if(m_pCreationDlg != NULL && IsWindow(m_pCreationDlg->GetSafeHwnd()))
	{
		if(m_pCreationDlg->IsKindOf(RUNTIME_CLASS(CRecvMemoDlg)))
			m_pCreationDlg->PostMessage(WM_CLOSE, 0, 0);
	}
}

void CMemoSendDlg::RegisterWindowClassFileListAddressee()
{
	CString strTmpClassName = _T("");
	strTmpClassName.Format(_T("Ntalk_InfoUserMgr_%X%X%X"),
		GetTickCount(),
		GetCurrentProcessId(),
		GetCurrentThreadId());

	RegisterWindowClass(strTmpClassName);

	CRect rtInfoUserMgr(0, 0, 0, 0);
	if (m_wndUserMgr.Create(strTmpClassName, _T("Ntalk_InfoUserMgr"), WS_CHILD | WS_VISIBLE | WS_CLIPCHILDREN | WS_CLIPSIBLINGS, rtInfoUserMgr, this, ID_MEMO_USERMGR))
	{
		m_wndUserMgr.SetImgDeletePath(_T("New_Info_UserMgr_Delete.png"), _T("New_Info_UserMgr_Delete_Over.png"));
		m_wndUserMgr.SetFontConfig(g_defaultFontFaceName, 9, FontStyleRegular, Color(255, 0, 0, 0));
	}

	strTmpClassName.Format(_T("Ntalk_MemoSend_FileList_%X%X%X"),
		GetTickCount(),
		GetCurrentProcessId(),
		GetCurrentThreadId());

	RegisterWindowClass(strTmpClassName);

	CRect rtFileList(0, 0, 0, 0);
	if (m_wndFileList.Create(strTmpClassName, _T("Ntalk_MemoSend_FileList"), WS_CHILD | WS_VISIBLE | WS_CLIPCHILDREN | WS_CLIPSIBLINGS, rtFileList, this, ID_MEMO_FILELIST))
	{
		m_wndFileList.SetImgProgressPath(_T("img_chat_progressive_bar.png"), _T("img_chat_progressive_bg_l.png"),
			_T("img_chat_progressive_bg_c.png"), _T("img_chat_progressive_bg_r.png"));
		m_wndFileList.SetFontConfig(g_defaultFontFaceName, 10, FontStyleRegular, Color(255, 0, 0, 0));
		
		m_wndFileList.SetMyPCText(LoadStringFromResource(IDS_STRING_MYPC));
		m_wndFileList.SetTitle(LoadStringFromResource(IDS_STRING454));
		m_wndFileList.SetSendSpeedTitle(LoadStringFromResource(IDS_STRING455));		
		m_wndFileList.SetRemainTimeTitle(LoadStringFromResource(IDS_STRING456));		
		m_wndFileList.UpdateSpeed(0, 0);
		m_wndFileList.SetTotalSize(0);
		m_wndFileList.SetCurSendSize(0);
		m_wndFileList.SetController(m_pSendMemoController);
		m_wndFileList.SetModel(this);
	}
}

void CMemoSendDlg::SetWindowTextAndSize()
{
	CRect rcWindow(0, 0, 0, 0);
	GetWindowRect(&rcWindow);
	rcWindow.right = rcWindow.left + NSD_DEF_MIN_SIZE_WIDTH;
	rcWindow.bottom = rcWindow.top + NSD_DEF_MIN_SIZE_HEIGHT;
	MoveWindow(rcWindow, TRUE);

	__ResourceLoad(TRUE);
	ModifyStyle(0, WS_CLIPCHILDREN);

	SetShowTitle(FALSE);

	SetWindowMinSize(NSD_DEF_MIN_SIZE_WIDTH, NSD_DEF_MIN_SIZE_HEIGHT); 
	SetExitBtnActHide(FALSE); 
	SetMoveTransParent(FALSE); 

	GET_APP()->SetWindowRegion(this);
}

void CMemoSendDlg::InitializeBySendType()
{
	SetTicket(g_pMessengerActor->GetMessengerTicket());

	SetDefaultExpand(true);
	//BOOL bInitSucessNote = FALSE;
	if(m_strWriteMode ==_T("new"))
	{
		SetDefaultExpand(false);
		;//bInitSucessNote = TRUE;
	}
	else if(0 == m_strWriteMode.CompareNoCase(_T("reply")))
	{	
		m_edMemoTitle.SetWindowText(GetSubject());
	}
	else if(0 == m_strWriteMode.CompareNoCase(_T("replyAll")))
	{
		m_edMemoTitle.SetWindowText(GetSubject());
	}
	else if(0 == m_strWriteMode.CollateNoCase(_T("forward")))
	{
		m_edMemoTitle.SetWindowText(GetSubject());

		int serverIndex = 1;
		std::vector<AttachFileInfo>::const_iterator fileIterator = m_attachFileInfoVector.begin();
		for (; fileIterator != m_attachFileInfoVector.end(); ++fileIterator)
		{
			AttachFileInfo fileInfo = *fileIterator;

			m_wndFileList.AddForwardFileItem(L"", fileInfo.fileName.c_str(), (DWORD)(fileInfo.fileSize), serverIndex);

			serverIndex++;
		}

		m_pSendMemoController->SetFileAttachIndex(serverIndex);
		m_pSendMemoController->SetFileAttachID(GetAttachID());
	}

	//if( GetSubject().IsEmpty() != true )
	//	m_bShowTitleEdit = TRUE;
	//else
	//	m_bShowTitleEdit = FALSE;

	//if(!bInitSucessNote)
	//{
	//	CString str;
	//	str.LoadString(IDS_STRING161);	// 서버 응답 오류로 초기화에 실패했습니다.
	//	TRACE(_T("%s \n"), GetNoteLastError());
	//	m_bInitializeSuccess = false;
	//	NMessageBox(this, str);
	//	CloseDialog();
	//	return;
	//}
}

void CMemoSendDlg::InitializeSmartEditor()
{
	m_SmartEditor.NewSmartEditorDocument((long)m_lNoteNum);
}

void CMemoSendDlg::InitializeAddressee()
{
	std::vector<ReceiverInfo>::const_iterator receiverIterator = m_receiverVector.begin();
	for(; receiverIterator != m_receiverVector.end(); ++receiverIterator)
	{
		ReceiverInfo receiverInfo = *receiverIterator;
		//AddNoteReceiver(receiverInfo.strID.c_str(), receiverInfo.strName.c_str());
		m_wndUserMgr.AddUserMgrItem(receiverInfo.strID.c_str(), receiverInfo.strName.c_str());
	}
}

void CMemoSendDlg::InitializeAttachFileList()
{
	std::vector<AttachFileInfo>::const_iterator fileIterator = m_attachFileInfoVector.begin();
	for(; fileIterator != m_attachFileInfoVector.end(); ++fileIterator)
	{
		AttachFileInfo fileInfo = *fileIterator;
		m_wndFileList.FileAdd(fileInfo.flepath.c_str());
	}
	
}

void CMemoSendDlg::SetTitleEdit()
{
	if (FALSE == GetSubject().IsEmpty())
	{
		m_bShowTitleEdit = TRUE;
	}
}

void CMemoSendDlg::InitializeAll()
{
	InitializeBySendType();
	InitializeAddressee();
	InitializeAttachFileList();
}

BEGIN_EVENTSINK_MAP(CMemoSendDlg, CSkinDialog)
	ON_EVENT(CMemoSendDlg, IDC_EXPLORER1, 259, CMemoSendDlg::DocumentCompleteExplorer1, VTS_DISPATCH VTS_PVARIANT)
END_EVENTSINK_MAP()

void CMemoSendDlg::DocumentCompleteExplorer1(LPDISPATCH pDisp, VARIANT* URL)
{
	IUnknown*  pUnk = NULL;
	LPDISPATCH lpWBDisp = NULL;
	HRESULT    hr;

	pUnk = m_SmartEditor.GetControlUnknown();

	if (pUnk == NULL)
	{
		ASSERT(pUnk);
		return;
	}

	hr = pUnk->QueryInterface(IID_IDispatch, (void**)&lpWBDisp);

	if (SUCCEEDED(hr))
	{
		if (pDisp == lpWBDisp)
		{
			CString strScript = _T("");

			if (m_bReplyContent)
			{
				strScript.Format(L"setSmartEditorFocus(\'<br><br><br>%s\')",UrlEncode(GetContent()));
				SetForegroundWindowForce(this->m_hWnd);
				SetWindowPos(&wndTop, 0, 0, 0, 0, SWP_NOMOVE | SWP_NOSIZE | SWP_NOACTIVATE);
				ExecScript(strScript);
				InputMethod::SetDefaultInputMethod(m_SmartEditor.GetSafeHwnd());
			}
			else if (m_bSetNoteInfo)
			{
				strScript.Format(L"setSmartEditorFocus(\'%s\')",UrlEncode(m_strNoteContent));
				SetForegroundWindowForce(this->m_hWnd);
				SetWindowPos(&wndTop, 0, 0, 0, 0, SWP_NOMOVE | SWP_NOSIZE | SWP_NOACTIVATE);
				ExecScript(strScript);
				InputMethod::SetDefaultInputMethod(m_SmartEditor.GetSafeHwnd());
			}

			if (m_bSetFocus)
			{
				//se2Focus가 동작을 하지 않아 setSmartEditorFocus에 빈문자열을 넣어 쓰고있다. 
				//ExecScript(L"se2Focus()");
				ExecScript(L"setSmartEditorFocus(\'\')");
				InputMethod::SetDefaultInputMethod(m_SmartEditor.GetSafeHwnd());
			}
		}

		lpWBDisp->Release();
	}
}

void CMemoSendDlg::OnBnClickedPartyCheck()
{
	if(m_chkParty.GetCheck())
		SetPartyCheck(TRUE);
	else
		SetPartyCheck(FALSE);
}

bool CMemoSendDlg::SetNoteInfo( CString strTitle, CString strContent )
{
	m_bSetNoteInfo =TRUE;
	m_edMemoTitle.SetWindowText(strTitle);

	m_strNoteContent = strContent;
	return true;
}

void CMemoSendDlg::SetSmartEditorFocus()
{
	m_bSetFocus =TRUE;
}


void CMemoSendDlg::SetForegroundWindowForce(HWND hWnd)
{
	if ( GetStyle() & WS_MINIMIZE )
	{
		ShowWindow( SW_SHOWNOACTIVATE);
		UpdateWindow();
	}

	HWND hWndForeground = ::GetForegroundWindow();
	if(hWndForeground == hWnd) return;

	DWORD Strange = ::GetWindowThreadProcessId(hWndForeground, NULL);
	DWORD My = ::GetWindowThreadProcessId(hWnd, NULL);
	::AttachThreadInput(Strange, My, TRUE);
	::SetForegroundWindow(hWnd);
	::BringWindowToTop(hWnd);
	::SetFocus(hWnd);
	::AttachThreadInput(Strange, My, FALSE); 

}

bool CMemoSendDlg::OnResponseGetAttachID(IGTWASActor *pActor, trid_t trid, GTWASCallErrorCode eErrorCode, LPCSTR szAttachID)
{
	if (!pActor)
		return false;

	if (m_tridGetAttachID != trid)
		return true;

	string strAttachID(szAttachID);

	if (eErrorCode != wasError_None || strAttachID.empty())
	{
		if (eErrorCode != wasError_None )
			m_strErrMsg = LoadStringFromResource(IDS_STRING_NEMSGDLG_FAIL_CONNECTSERVER);
		else
			m_strErrMsg = /*LoadStringFromResource(IDS_STRING161)*/_T("쪽지 전송 정보 요청이 실패하였습니다.\n잠시 후 다시 시도해주세요.");	// 다국어

		this->PostMessage(WM_MEMOSENDDLG_MESSAGE_POPUP_CLOSE, (WPARAM)&m_strErrMsg, NULL);

		return false;
	}

	m_pSendMemoController->SetFileAttachID( strAttachID );

	if( m_attachFileInfoVector.empty() != true )
	{
		InitializeAttachFileList();
	}

	if( m_strWriteMode.Compare(_T("new")) != 0)
	{
		// ReplyBody를 가져온다.
		trid_t tridGetReplyBody;
		string strLangcode = GetLanguageString();
		bool bRequest = g_pMessengerActor->GetWASActor()->RequestGetReplyBody(m_strWriteMode.GetString(), m_lNoteNum, strLangcode.c_str(), &tridGetReplyBody);
		if( bRequest  )
			SetReplyBodyTrid(tridGetReplyBody);
		else
		{
			m_strErrMsg = _T("원문 요청에 실패하였습니다. 잠시 후 다시 시도해 주십시요.");
			this->PostMessage(WM_MEMOSENDDLG_MESSAGE_POPUP, (WPARAM)&m_strErrMsg, NULL);
		}
	
	}

	return false;
}

bool CMemoSendDlg::OnResponseGetReplyBody(IGTWASActor *pActor, trid_t trid, GTWASCallErrorCode eErrorCode, NoteReplyBody &replyBodyInfo)
{
	if (!pActor)
		return false;

	if (m_tridGetReplyBody != trid)
		return true;

	if (eErrorCode != wasError_None)
	{
		m_strErrMsg = LoadStringFromResource(IDS_STRING_NEMSGDLG_FAIL_CONNECTSERVER);
		this->PostMessage(WM_MEMOSENDDLG_MESSAGE_POPUP_CLOSE, (WPARAM)&m_strErrMsg, NULL);
		return false;
	}

	SetAttachID(replyBodyInfo.strAttachID.c_str());
	SetSubject(replyBodyInfo.strSubject.c_str());
	SetContent(replyBodyInfo.strContent.c_str());

	m_receiverVector.clear();
	std::vector<ReceiverInfo>::const_iterator itr_receiver = replyBodyInfo.vecReceiverVector.begin();
	for(; itr_receiver != replyBodyInfo.vecReceiverVector.end(); itr_receiver++)
	{
		ReceiverInfo receiver;

		receiver.strID = itr_receiver->strID;
		receiver.strName = itr_receiver->strName;
		receiver.strCellPhone = itr_receiver->strCellPhone;

		m_receiverVector.push_back(receiver);
	}

	m_attachFileInfoVector.clear();
	std::vector<AttachFileInfo>::const_iterator itr_attachfile = replyBodyInfo.vecAttachFileInfo.begin();
	for(; itr_attachfile != replyBodyInfo.vecAttachFileInfo.end(); itr_attachfile++)
	{
		AttachFileInfo attachfile;

		attachfile.downloadUrl = itr_attachfile->downloadUrl;
		attachfile.fileName = itr_attachfile->fileName;
		attachfile.fileSize = itr_attachfile->fileSize;
		attachfile.flepath = itr_attachfile->flepath;

		m_attachFileInfoVector.push_back(attachfile);
	}

	int serverIndex = 1;
	std::vector<AttachFileInfo>::const_iterator fileIterator = m_attachFileInfoVector.begin();
	for (; fileIterator != m_attachFileInfoVector.end(); ++fileIterator)
	{
		AttachFileInfo fileInfo = *fileIterator;

		m_wndFileList.AddForwardFileItem(L"", fileInfo.fileName.c_str(), (DWORD)(fileInfo.fileSize), serverIndex);
		serverIndex++;
	}
	m_pSendMemoController->SetFileAttachIndex(serverIndex);
	m_pSendMemoController->SetFileAttachID(GetAttachID());

	m_edMemoTitle.SetWindowText(GetSubject());
	InitializeAddressee();
	//InitializeAttachFileList();

	InitializeSmartEditor();
	IsReplyContent(TRUE);
	if(m_attachFileInfoVector.size() == 0)
	{
		SetDefaultExpand(false);
	}

	m_wndFileList.ExpandAttachList(m_bDefaultExpand);
	ShowWindow(SW_SHOW);

#ifdef _DEBUG 
	#ifdef TEST_SEND_MEMO
		SetTimer(TIMER_TEST_SENDMEMO_AUTO_REPLY, 3000, NULL);
	#endif
#endif

	return false;
}

bool CMemoSendDlg::OnResponseSendNote(IGTWASActor *pActor, trid_t trid, GTWASCallErrorCode nWasErrorCode, int nJsonErrorCode, LPCWSTR strResponseMsg)
{
	if (m_tridSendNote != trid)
		return true;
	
	if( nWasErrorCode != wasError_None )
	{
		NTALK_LOG->Error(L"[NOTE] OnResponseSendNote = %d, %d, %s.", (int)nWasErrorCode, nJsonErrorCode, strResponseMsg);

		m_strErrMsg = LoadStringFromResource(IDS_STRING_NEMSGDLG_FAIL_CONNECTSERVER);

		this->PostMessage(WM_MEMOSENDDLG_MESSAGE_POPUP, (WPARAM)&m_strErrMsg, NULL);
		EnableSend();

		return false;
	}

	NTALK_LOG->Debug(L"[NOTE] OnResponseSendNote = %d, %d, %s.", (int)nWasErrorCode, nJsonErrorCode, strResponseMsg);

	switch (nJsonErrorCode)
	{
	case 0:
		if (GET_CONFIG()->GetNoteCloseType() == 1)
			CloseRecvNoteDlg();
		this->PostMessage(WM_CLOSE, NULL, NULL);
		break;
	case -1011:
		m_strErrMsg = LoadStringFromResource(IDS_STRING151);
		//NMessageBox(this, LoadStringFromResource(IDS_STRING151));
		this->PostMessage(WM_MEMOSENDDLG_MESSAGE_POPUP, (WPARAM)&m_strErrMsg, NULL);

		EnableSend();
		break;
	default:
		m_strErrMsg = strResponseMsg;
		this->PostMessage(WM_MEMOSENDDLG_MESSAGE_POPUP, (WPARAM)&m_strErrMsg, NULL);
		EnableSend();
		break;
	}

	return false;
}

LRESULT CMemoSendDlg::OnMessageBoxClose( WPARAM wParam, LPARAM lParam )
{

	CString* pStrMessageBox = (CString*)wParam;
	CString StrMessageBox(*pStrMessageBox);

	NMessageBox(this, StrMessageBox);
	PostMessage(WM_CLOSE, NULL, NULL);
	return 0L;
}

LRESULT CMemoSendDlg::OnMessageBox( WPARAM wParam, LPARAM lParam )
{
	CString* pStrMessageBox = (CString*)wParam;
	CString strMessageBox(*pStrMessageBox);
	if (this->GetSafeHwnd() && ::IsWindow(this->m_hWnd) )
	{
		NMessageBox(this, strMessageBox);
	}
	return 0L;
}


void CMemoSendDlg::OnTimer(UINT_PTR nIDEvent)
{
	if( nIDEvent == TIMER_TEST_SENDMEMO_AUTO_REPLY )
	{
		KillTimer(nIDEvent);
		OnBnClickedSendButton();
	}

	__super::OnTimer(nIDEvent);
}

LRESULT CMemoSendDlg::OnBnClickedSendMemoMenuButton( WPARAM wParam, LPARAM lParam )
{
	CRect rectTopMenu = GetCustomBtnRect();	

	CRect rtDlg(0, 0, 0, 0);
	GetWindowRect(&rtDlg);

    POINT pt = { 0 };
	pt.x = rtDlg.left + rectTopMenu.left;
	pt.y = rtDlg.top + rectTopMenu.bottom;

	CMenu menuList;
	menuList.LoadMenu(IDR_MENU_SENDMEMO);
	

	menuList.CheckMenuItem(ID_SENDMEMO_TOP, m_bTopMost ? MF_CHECKED : MF_UNCHECKED);
	menuList.EnableMenuItem(ID_SENDMEMO_ADDUSER, MF_ENABLED);
	menuList.EnableMenuItem(ID_SENDMEMO_ADDFILE, MF_ENABLED);
	menuList.EnableMenuItem(ID_SENDMEMO_RSV, MF_ENABLED);
	menuList.GetSubMenu(0)->TrackPopupMenu(TPM_LEFTALIGN|TPM_RIGHTBUTTON, pt.x, pt.y, this);

	PostMessage(WM_NCMOUSELEAVE, 0, 0);

	return 0L;
}	

void CMemoSendDlg::OnMenuTopMost()
{
	if (m_bTopMost)
	{
		m_bTopMost = false;
		SetWindowPos(&wndNoTopMost, 0, 0, 0, 0, SWP_NOSIZE | SWP_NOMOVE);
	}
	else
	{
		m_bTopMost = true;
		SetWindowPos(&wndTopMost, 0, 0, 0, 0, SWP_NOSIZE | SWP_NOMOVE);
	}
}

void CMemoSendDlg::OnMenuAddUser()
{
	this->SendMessage(UM_USERMGR_ADDUSERBTN, (WPARAM)0, (LPARAM)0);
}

void CMemoSendDlg::OnMenuAddFile()
{
	if (m_wndFileList.GetSafeHwnd())
		m_wndFileList.OnBtnFileAdd();
}

void CMemoSendDlg::OnMenuReservation()
{
	m_wndFileList.SetReserveCheck(!m_wndFileList.GetReserveCheck());
	if (m_wndFileList.GetReserveCheck())
	{
		OnRsvSelectedChange();
	}
	
}

void CMemoSendDlg::RecvMemoDlgIsClosed( CDialog* pDialog )
{
	if( m_pCreationDlg == pDialog )
		m_pCreationDlg = NULL;
}


void CMemoSendDlg::OnButtonClicked( COKCancelButtons::BUTTONS button )
{

	ASSERT(button != COKCancelButtons::All);


	if(button == COKCancelButtons::Cancle)
	{
		OnBnClickedCancelButton();
	}
	

	if(button == COKCancelButtons::OK)
	{
		OnBnClickedSendButton();
	}
}

void CMemoSendDlg::SetDefaultExpand( bool bExpand )
{

	m_bDefaultExpand = bExpand;
}

void CMemoSendDlg::OnExpandChanged( bool bExpand, int nDy )
{

	if(bExpand)
	{
		SetWindowMinSize(NSD_DEF_MIN_SIZE_WIDTH, NSD_DEF_MIN_SIZE_EXPAND_HEIGHT); 
	}
	else
	{
		SetWindowMinSize(NSD_DEF_MIN_SIZE_WIDTH, NSD_DEF_MIN_SIZE_HEIGHT); 
	}

    CRect rcWindow(0, 0, 0, 0);
	GetWindowRect(&rcWindow);
	rcWindow.bottom += nDy;
	MoveWindow(rcWindow, TRUE);
}

